$regfile = "m8def.dat"
$crystal = 8000000

Config Portb = &B01111001
Config Portc = &B11110101
Config Portd = &B11011111

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.3 , Db5 = Portd.2 , Db6 = Portd.1 , Db7 = Portd.0 , E = Portd.6 , Rs = Portb.0

Config Adc = Single , Prescaler = Auto , Reference = Internal
'konfiguracja ADC = tryb pojedynczej konwersji, automatyczny dobr prescalera, wewntrzne napicie odniesienia rwne 2,56V

Dim T1 As Word
Dim Tmp As Single                                           'wynik konwersji ADC dla kanau nr
Dim Tmphis As Single
Dim V As String * 10
Dim Vs As String * 10
Dim Dv As Single
Dim Sw As Bit
Sw = 0
Dim Count As Integer
Count = 0
Dim Tchar As Byte
Dim Trel As Byte

Dim Prog As Single
Dim Proglcd As Integer

Portb = &B10000110
Portc = &B00001000
Portd = &B00100000

Dim F1 As Bit
Dim F2 As Bit
Dim F3 As Bit
Dim F4 As Bit

Cls
Cursor Off Noblink
Upperline : Lcd "BATTERY CHARGER"
Lowerline : Lcd "by radekq"
Wait 2
Cls
Do
 F1 = Pinb.2
 F2 = Pinb.1
 F3 = Pind.5
 F4 = Pinb.7
 Toggle F1
 Toggle F2
 Toggle F3
 Toggle F4
 Upperline : Lcd "SET CONFIG BITS:"
 Lowerline : Lcd F1 + " " + F2 + " " + F3 + " " + F4 + "   OK?"
 If F2 = 1 And F3 = 1 Then
  Wait 1
  Cls
  Upperline : Lcd "SET CONFIG BITS:"
  Lowerline : Lcd "          OK?"
  Waitms 500
 Else
  Debounce Pinc.3 , 0 , Charging , Sub
 End If
Loop

Charging:
 If F2 = 1 Then
  Cls
  Upperline : Lcd "deltaV CONTROL"
  Lowerline : Lcd "WAS TURNED OFF"
  Wait 5
 End If

 If F3 = 1 Then
  Cls
  Upperline : Lcd "Vmax CONTROL"
  Lowerline : Lcd "WAS TURNED OFF"
  Wait 5
 End If

 Tchar = 3                                                  'Tchar
 Trel = 1                                                   'Trel

 Cls
 Gosub Batterytest

 Do
  If Count = 0 Then
   Gosub Getvoltage
   Vs = Fusing(tmp , "#.##")
   Upperline : Lcd "        CHARGING"
  End If

  Set Portc.2
  Set Portc.4

  Wait Tchar

  Reset Portc.2
  Reset Portc.4

  Gosub Baterrorcheck

  Wait Trel

  Gosub Getvoltage                                          'pomiar napicia po czasie trel od odczenia adowania (realna warto napicia baterii)

  If Sw = 0 Then
   Dv = Tmp - Tmphis
   If Dv < 0 And F2 = 0 Then                                'DV !!!!!
    Goto Stopbydv
   End If
   Tmphis = Tmp
   Sw = 1
  End If

  If Tmp > 1.90 And F3 = 0 Then                             'VMAX !!!!!
   Goto Stopbyvmax
  End If

  Prog = Tmp / 1.5
  Prog = Prog * 100
  Proglcd = Round(prog)

  Upperline : Lcd "Va=" + V + " CHARGING"
  Lowerline : Lcd "Vs=" + Vs + "   " + Proglcd + "%    "

  Count = Count + 1
  If Count = 50 Then                                        'COUNT (DV) !!!!!
   Sw = 0
   Count = 1
  End If
 Loop
Return

Getvoltage:
 T1 = Getadc(1 , 64)
 Tmp = T1                                                   'konwersja na single
 Tmp = Tmp * 0.0026
 V = Fusing(tmp , "#.##")
Return

Batterytest:
 Upperline : Lcd "Battery test..."
 Wait 1
 If F1 = 1 Then
  Lowerline : Lcd "SKIPPED"
  Wait 1
  Cls
  Return
 End If

 Set Portc.2
 Set Portc.4
 Waitms 500
 Reset Portc.2
 Reset Portc.4
 Waitms 500
 Gosub Getvoltage

 If Tmp < 1.3 Then
  Lowerline : Lcd "FAILED"
  Wait 1
  Do
  Loop
 Else
  Lowerline : Lcd "PASSED"
  Wait 1
  Cls
  Return
 End If
Return

Baterrorcheck:
 Gosub Getvoltage                                           'pomiar napicia bezporednio po odczeniu adowania (potrzebny do detekcji wypadnicia baterii z adowarki)
 If Tmp = 0 Then
  Cls
  Upperline : Lcd "        BATERROR"
  Reset Portc.2
  Do
   Set Portc.5
   Reset Portc.4
   Waitms 250
   Reset Portc.5
   Set Portc.4
   Waitms 250
  Loop
 End If
Return

Stopbyvmax:
 Upperline : Lcd "Va=" + V + "     Vmax"
 Lowerline : Lcd "Vs=" + Vs + "   " + Proglcd + "%    "
 Set Portc.5
 Reset Portc.2
 Reset Portc.4
 If F4 = 1 Then
  Goto Batterybooster
 End If
 Do
 Loop
End

Stopbydv:
 Upperline : Lcd "Va=" + V + "   deltaV"
 Lowerline : Lcd "Vs=" + Vs + "   " + Proglcd + "%    "
 Set Portc.5
 Reset Portc.2
 Reset Portc.4
 If F4 = 1 Then
  Goto Batterybooster
 End If
 Do
 Loop
End

Batterybooster:
 Count = 300
 Do
  Lowerline : Lcd "Waiting...   " + Count + " "
  Wait 1
  If Count = 1 Then
   Lowerline : Lcd "BOOST...        "

   Set Portc.2
   Set Portc.4
   Wait 10
   Reset Portc.2
   Reset Portc.4
   Gosub Baterrorcheck

   Wait 1
   Set Portc.2
   Set Portc.4
   Wait 10
   Reset Portc.2
   Reset Portc.4
   Gosub Baterrorcheck

   Wait 1
   Set Portc.2
   Set Portc.4
   Wait 10
   Reset Portc.2
   Reset Portc.4
   Gosub Baterrorcheck

   Wait 1
   Set Portc.2
   Set Portc.4
   Wait 10
   Reset Portc.2
   Reset Portc.4
   Gosub Baterrorcheck

   Wait 1
   Set Portc.2
   Set Portc.4
   Wait 10
   Reset Portc.2
   Reset Portc.4
   Gosub Baterrorcheck

   Wait 1
   Set Portc.2
   Set Portc.4
   Wait 10
   Reset Portc.2
   Reset Portc.4
   Gosub Baterrorcheck

   Lowerline : Lcd "BOOST... DONE!"
   Do
   Loop
  End If
  Decr Count
 Loop